SystemOrganization addCategory: #'Keymapping-Tools-Spec'!

ComposableModel subclass: #KMDescription
	instanceVariableNames: 'droplist list okButton collectingBlock categories displayList sortingBlock updatingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tools-Spec'!

!KMDescription commentStamp: '<historical>' prior: 0!
A KMDescription is a window showing the description of shortcuts for a specified set of symbols reprensenting KMCategories!

!KMDescription class methodsFor: 'specs' stamp: 'bvr 6/4/2012 14:49'!
defaultSpec
	<spec>
	
	^ {#ComposableSpec.
			#add:. {{#model. #droplist. }.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0@0 corner: 0.6@0). (0@0 corner: 0@25)}}.
			#add:. {{#model. #displayList.}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0.6@0 corner: 1@0). (0@0 corner: 0@25)}}.
			#add:. {{#model. #list.}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0@0 corner: 1@1). (0@25 corner: 0@(-25))}}.
			#add:. {{#model. #okButton.}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (1@1 corner: 1@1). (-75@(-25) corner: 0@0)}}}! !

!KMDescription class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 4/6/2012 17:23'!
example

	| d |
	d := KMDescription new.
	d categories: #(GlobalShortcuts MonticelloShortcuts TextEditor).
	d openWithSpec! !

!KMDescription class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/6/2012 15:46'!
title

	^ 'Shortcuts description'! !

!KMDescription methodsFor: 'accessing' stamp: 'GuillermoPolito 5/1/2012 12:26'!
categories
	
	^ categories! !

!KMDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/6/2012 15:34'!
categories: aCollectionOfSymbols
	| cats |
	
	cats := aCollectionOfSymbols collect: [:e | KMRepository default categoryForName: e].
	categories contents: cats! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:38'!
displayList
	
	^ displayList! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
droplist
	
	^ droplist! !

!KMDescription methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/6/2012 15:49'!
initialExtent

	^  (600@350)! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 16:37'!
initialize
	"Initialization code for KMDescription"

	categories := nil asValueHolder.
	super initialize.

	updatingBlock := [:col || dropListItems |
		dropListItems := col collect: [:cat | DropListItem named: cat name do: [| items |
																items := (cat entriesAt: #all) keymaps collect: [:e | collectingBlock value: e ].
																list items:  (items sorted: sortingBlock) ]].
		droplist items: dropListItems ].! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 18:25'!
initializePresenter
		
	displayList whenSelectedItemChanged: [ updatingBlock value: categories contents ].
	categories whenChangedDo: [:col | updatingBlock value: col ].
	okButton action: [ self delete ].! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 16:37'!
initializeWidgets

	self instantiateModels: #(
		droplist DropListModel
		list MultiColumnListModel
		okButton ButtonModel
		displayList DropListModel ).
	
	displayList items: {
		DropListItem 
			named:'shortcut	:	description' 
			do: [ 
					collectingBlock := [:e | {e shortcut asString. ':'. e description asString} ].
					sortingBlock := [:a :b | true ]].
		DropListItem 
			named:'description	:	shortcut' 
			do: [ 
					collectingBlock := [:e | {e description asString. ':'. e shortcut asString} ].
					sortingBlock := [:a :b | a first < b first ]]}.
	
	list 
		displayBlock: [ :e | e ];
		allowToSelect: false.

	okButton 
			label: 'Close';
			state: false! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
list
	
	^ list! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
okButton
	
	^ okButton! !
